<template>
  <v-card class="imtd-card ma-0 pt-5 pb-7 pr-5 pl-9">
    <div
      v-if="loading"
      class="d-flex justify-center align-center"
      style="height: 100%"
    >
      <v-progress-circular indeterminate color="#7319D5" size="60" width="6" />
      <div class="mt-4 loading-text" />
    </div>

    <v-row v-else>
      <v-col md="3" cols="12" class="text-center">
        <div>Índice de Madurez en Transformación Digital</div>
        <v-progress-circular
          class="mt-3"
          :rotate="-90"
          :size="140"
          :width="16"
          :value="imtd"
          color="#16C62E"
        >
          <span class="percentage-text">{{ imtd }}%</span>
        </v-progress-circular>
      </v-col>
      <v-col md="9" cols="12">
        <div
          class="text-center text-md-left"
          style="color: #7319d5; font-weight: 600"
        >
          <span class="title-idx-subtitle">
            <span v-if="imtd <= 40">Nivel Básico</span>
            <span v-if="imtd > 40 && imtd <= 60">Nivel Inicial</span>
            <span v-if="imtd > 60 && imtd <= 80">Nivel Estratégico</span>
            <span v-if="imtd > 80">Nivel competitivo</span>
          </span>
        </div>
        <div class="text-end mb-5 d-md-none d-block">
          <v-icon style="cursor: pointer" large @click="showText = !showText">
            {{ showText ? "mdi-chevron-up" : "mdi-chevron-down" }}
          </v-icon>
        </div>
        <div v-if="showText || desktop">
          <div class="roboto body-idx-text mt-3" style="font-size: 16px">
            <div
              style="white-space: pre-wrap; word-wrap: break-word"
              v-if="imtd <= 40"
            >
              {{ levels[0] }}
            </div>
            <div
              style="white-space: pre-wrap; word-wrap: break-word"
              v-if="imtd > 40 && imtd <= 60"
            >
              {{ levels[1] }}
            </div>
            <div
              style="white-space: pre-wrap; word-wrap: break-word"
              v-if="imtd > 60 && imtd <= 80"
            >
              {{ levels[2] }}
            </div>
            <div
              style="white-space: pre-wrap; word-wrap: break-word"
              v-if="imtd > 80"
            >
              {{ levels[3] }}
            </div>
          </div>
          <div class="roboto mt-3 text-center text-md-left">
            <strong style="font-size: 16px"
              >Conoce el detalle de tus brechas digitales y un plan de trabajo a
              la medida al suscribirte.
            </strong>
          </div>
          <div class="d-flex mt-3 justify-center justify-md-start">
            <v-btn
              rounded
              color="#16C62E"
              class="button-text white--text"
              :to="{ name: 'plans' }"
            >
              ver planes
            </v-btn>
          </div>
        </div>
      </v-col>
    </v-row>
  </v-card>
</template>

<script>
import CompanyService from "@/services/companyService";
import dtService from "@/services/dtService";
import currentUserService from "@/services/currentUserService";
import { mapActions, mapGetters } from "vuex";

export default {
  data() {
    return {
      imtd: 0,
      levels: [
        "La empresa enfrenta el futuro con mentalidad mayoritariamente analógica, sin plan digital. Suma innovaciones aisladas. Opera con sistemas rígidos y poco eficientes para adaptarse a los intereses de los clientes y del mercado. Aspira a incorporar la Transformación Digital, pero las decisiones son tardías y lentas. Falta un liderazgo que impulse el proceso de transformación. Aparecen resistencias. La organización persiste en hacer las cosas como hasta ahora, sin integrar competencias digitales. La organización está enfocada en una rentabilidad de corto plazo. Su competitividad futura es baja.",
        "La empresa integra innovaciones en procesos específicos para bajar costos y aumentar margen. Resuelve problemas actuales con tecnologías, más que cambiar la forma de hacer las cosas. Pone en marca acciones digitales, sin claridad sobre el valor que tendrán en el negocio futuro. Persisten resistencias y una cultura de trabajo en silos, sin lograr agilizar la transformación digital, ni impregnar a toda la organización. Necesita un propósito alineado a un proyecto digital estructurado, y liderazgos comprometidos con una ruta hacia la Transformación integral. Incorpora competencias digitales para adoptar nuevos modelos de negocio. Pone en marcha algunos servicios con foco en los clientes y su comportamiento, priorizando acciones de marketing.",
        "La empresa alinea su propósito a la Transformación Digital como estrategia de negocio. Proyecta una cultura orientada al cliente y data driven, para tomar decisiones, escalar el negocio, aumentar la velocidad de salida al mercado y adaptar la propuesta de valor a escenarios dinámicos. Establece liderazgos comprometidos con los cambios. Incorpora modelos de aprendizaje continuo. Impulsa la colaboración entre equipos autónomos y multidisciplinarios. Establece alianzas con ecosistemas externos para lograr eficiencias y mejorar la rentabilidad futura. La data, innovación y las tecnologías son activos estratégicos transversales para volverse más ágil, automatizar procesos y escalar. Mapea la experiencia de los clientes de principio a fin, monitorea su satisfacción, interactúa con ellos en espacios digitales y gestiona activamente fallas operacionales.",
        "La estrategia, proyecto y gestión de Transformación Digital es central y transversal. Completamente integrada al negocio, busca crear ventajas competitivas a largo plazo en contextos dinámicos. La tecnología es su aliado en la nube. Promueve una nueva mentalidad a través de un propósito vinculante, potenciando una inteligencia colectiva. Nace una cultura corporativa flexible, auto motivada y abierta a la innovación. Surgen liderazgos que permiten orquestar los cambios de forma ágil, distribuyendo las decisiones críticas. Cuenta con un ecosistema que incentiva el aprendizaje continuo, incorporando los errores o fallos de forma constructiva, prototipando para escalar rápido. Los clientes son entendidos como una red, los conecta de manera multicanal y sin fricciones, motivándolos a colaborar en crear su oferta de valor. La data es un activo para conocerlos y anticiparse a la futura interacción que tendrán con sus productos y servicios; el fin, entregar una experiencia exitosa.",
      ],
      loading: true,
      showText: false,
    };
  },
  created() {
    this.steps = this.getSteps;
    currentUserService
      .currentUserData()
      .then((userData) => {
        this.user = userData;
        dtService
          .getSurveyComplete("a123", this.user.id)
          .then((questions) => {
            this.SET_PERCENTAGE(
              Math.floor((questions.answered / questions.total) * 100)
            );

            if (this.getPercentage != 100) {
              this.loading = false;
            } else {
              this.getDti(this.user.id, questions.surveyId);
            }
          })
          .catch((err) => {
            this.$log.error(err);
          });
      })
      .catch((err) => this.$log.error(err));
  },
  methods: {
    ...mapActions("UserStore", ["SET_PERCENTAGE"]),
    getCompany() {
      CompanyService.getCompanyProfile()
        .then((company) => {
          this.clientType = this._.get(company, "type");
        })
        .catch((err) => console.log(err));
    },
    getDti(userId, surveyId) {
      dtService
        .getDti(userId, surveyId)
        .then((dti) => {
          this.imtd = (dti.score * 10).toFixed(0);
          this.loading = false;
        })
        .catch((err) => {
          this.$log.error(err);
        });
    },
  },
  computed: {
    ...mapGetters("UserStore", ["getPercentage", "getSteps"]),
    desktop() {
      return (
        this.$vuetify.breakpoint.md ||
        this.$vuetify.breakpoint.lg ||
        this.$vuetify.breakpoint.xl
      );
    },
  },
};
</script>

<style lang="css" scoped>
.imtd-card {
  border-color: #7319d5;
  border-style: solid;
  border-width: 1px;
}
.percentage-text {
  font-family: Roboto;
  font-style: normal;
  font-weight: bold;
  font-size: 30px;
  line-height: 35px;
  text-align: center;
  text-transform: uppercase;
  color: #7319d5;
}
</style>
